
#include "priv_game.h"
#include "aiclient.h"
#include "net.h"

struct civ_game game;
select_nation_cbt cb_select_nation;
game_started_notify_cbt cb_game_started_notify;
new_year_notify_cbt cb_new_year_notify;
name_new_city_cbt cb_name_new_city;

void set_select_nation_cb(select_nation_cbt callback)
{
	cb_select_nation=callback;
}

void set_game_started_notify_cb(game_started_notify_cbt callback)
{
	cb_game_started_notify=callback;
}

void set_new_year_notify_cb(new_year_notify_cbt callback)
{
	cb_new_year_notify=callback;
}

void set_name_new_city_cb(name_new_city_cbt callback)
{
	cb_name_new_city=callback;
}

void update_game_info(struct packet_game_info *p)
{
	int i;

	game.start_gold=p->gold;
	game.tech=p->tech;
	game.techlevel=p->techlevel;
	game.skill_level=p->skill_level;
	game.timeout=p->timeout;

	game.end_year=p->end_year;
	game.year=p->year;
	game.min_players=p->min_players;
	game.max_players=p->max_players;
	game.nplayers=p->nplayers;
	game.globalwarming=p->globalwarming;
	game.heating=p->heating;
	if(get_client_state()!=CLIENT_GAME_RUNNING_STATE) {
		game.player_id=p->player_idx;
	}
	for(i=0; i<A_LAST/*game.num_tech_types*/; i++)
		game.global_advances[i]=p->global_advances[i];
	for(i=0; i<B_LAST; i++)
		game.global_wonders[i]=p->global_wonders[i];
  
	game.techpenalty=p->techpenalty;
	game.foodbox=p->foodbox;
	game.civstyle=p->civstyle;
	game.spacerace=p->spacerace;
}

void turn_done(void)
{
	struct packet_generic_message gen_packet;
	gen_packet.message[0]='\0';

	send_packet_generic_message(&aconnection, PACKET_TURN_DONE, &gen_packet);
}

void make_revolution(void)
{
	struct packet_player_request packet;

	send_packet_player_request(&aconnection, &packet, 
							   PACKET_PLAYER_REVOLUTION);
}
