/********************************************************************** 
 Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
***********************************************************************/
#ifndef FC__NATION_H
#define FC__NATION_H

#include "shared.h"		/* MAX_LEN_NAME */

#define MAX_NUM_TECH_GOALS 10
#define MAX_NUM_NATIONS  63
#define MAX_NUM_LEADERS  16

typedef int Nation_Type_id;

struct player;

enum advisor_type {ADV_ISLAND, ADV_MILITARY, ADV_TRADE, ADV_SCIENCE, 
				   ADV_FOREIGN, ADV_ATTITUDE, ADV_DOMESTIC, ADV_LAST};

struct nation_type {
	char name[MAX_LEN_NAME];
	char name_plural[MAX_LEN_NAME];
	char flag_graphic_str[MAX_LEN_NAME];
	char flag_graphic_alt[MAX_LEN_NAME];
	int  leader_count;
	char *leader_name[MAX_NUM_LEADERS];
	int  leader_is_male[MAX_NUM_LEADERS];
	int city_style;
	char **default_city_names;

	/* untranslated copies: */
	char name_orig[MAX_LEN_NAME];
	char name_plural_orig[MAX_LEN_NAME];

	/* only valid for the select nation callback */
	int is_selectable;
};

struct nation_type *find_nation_by_id(Nation_Type_id nation);
struct nation_type *find_nation_by_name(char *name);
struct nation_type *find_nation_by_player(int player_id);
int nation_exists(Nation_Type_id nation);

/* Unused Functions */

#if 0
char **get_nation_leader_names(Nation_Type_id nation, int *num);
int get_nation_leader_sex(Nation_Type_id nation, char *name);

int check_nation_leader_name(Nation_Type_id nation, char *name);
#endif

#endif  /* FC__NATION_H */
