
#include <stdio.h>
#include <assert.h>

#include "client.h"
#include "game.h"
#include "government.h"

/* ----------- game related ------------------------ */
void my_select_nation(int *nation_id_store, int *is_male_store,
					  int *city_style_store, 
					  char *ruler_name_store)
{
	int nation,leader;
	struct nation_type *p;

	for(nation=0;;nation++)
	{
		p=find_nation_by_id(nation);
		assert(p);
		if(p->is_selectable)
			break;
	}
	*nation_id_store=nation;
	*city_style_store=0;

	leader=0;
	*is_male_store=p->leader_is_male[leader];
	strcpy(ruler_name_store,p->leader_name[leader]);
	return;
}

void show_science()
{
	struct player *pplayer=find_myself();

	return;
	printf("science: %d/%d from %s goal is %s last tech research is %s\n",
		   pplayer->research.researched,
		   pplayer->research.researchpoints,
		   find_tech_by_id(pplayer->research.researching)->name,
		   find_tech_by_id(pplayer->research.tech_goal)->name,
		   find_tech_by_id(pplayer->research.tech_last_researched)->name);
}

void my_game_started_notify()
{
	show_science();
	turn_done();
}

static void try_to_buy()
{
	struct city *pcities[10];
	int cities,i,best_index=-1,best_gold_per_turn=999999;

	cities=find_cities_by_player(game.player_id,10,pcities);
	for(i=0;i<cities;i++)
	{
		int gold_per_turn;

		if(pcities[i]->turns_to_complete<2 ||
		   pcities[i]->buy_cost > find_myself()->economic.gold)
			continue;

		gold_per_turn=pcities[i]->buy_cost/pcities[i]->turns_to_complete;
		if(gold_per_turn<best_gold_per_turn)
		{
			best_index=i;
			best_gold_per_turn=gold_per_turn;
		}
	}
	if(best_index==-1)
		return;

	buy_city_construction(pcities[best_index]->id);
}

void my_new_year_notify()
{
	show_science();
	try_to_buy();
	turn_done();
}

void my_name_new_city(int unit_id, char *suggested_name, 
					  char *name_store)
{
	sprintf(name_store,"%s-founded-by-%d",suggested_name,unit_id);
}

void my_choose_science(int *tech_to_research_store,
					   int *tech_goal_store)
{
	struct advance *tech;

	if(find_myself()->research.tech_last_researched==
	   find_tech_by_name("Monarchy")->id)
		make_revolution();

	tech=find_tech_by_name("Monarchy");
	assert(tech);
	if(get_invention(game.player_id, tech->id) != TECH_KNOWN)
	{
		*tech_goal_store=tech->id;
		return;
	}

	tech=find_tech_by_name("Railroad");
	assert(tech);
	if(get_invention(game.player_id, tech->id) != TECH_KNOWN)
	{
		*tech_goal_store=tech->id;
		return;
	}

	find_tech_by_name("Democracy");
	assert(tech);
	if(get_invention(game.player_id, tech->id) != TECH_KNOWN)
	{
		*tech_goal_store=tech->id;
		return;
	}
}

void my_choose_government(int *government_id_store)
{
	struct government *g;

	g=find_government_by_name("Democracy");
	assert(g);
	if(player_can_change_to_government(game.player_id,g->id))
	{
		*government_id_store=g->id;
		return;
	}
	
	g=find_government_by_name("Republic");
	assert(g);
	if(player_can_change_to_government(game.player_id,g->id))
	{
	   *government_id_store=g->id;
	   return;
	}

	g=find_government_by_name("Monarchy");
	assert(g);
	if(player_can_change_to_government(game.player_id,g->id))
	{
	   *government_id_store=g->id;
	   return;
	}

	g=find_government_by_name("Despotism");
	assert(g);
	if(player_can_change_to_government(game.player_id,g->id))
	{
	   *government_id_store=g->id;
	   return;
	}
	assert(0);
}


/* ----------- unit related ------------------------ */
static void move_explorer(struct unit *punit)
{
	int i;

	if(punit->moves_left==0)
		return;

	for(i=0;i<10;i++)
	{
		int new_x,new_y;
		int dx[]={-1,0,1,  -1,0,1, -1,0,1};
		int dy[]={-1,-1,-1, 0,0,0,  1,1,1};

		if(i==4)
			continue;
		new_x=punit->x+dx[i];
		new_y=punit->y+dy[i];

		if(!can_move_unit(punit->id,new_x,new_y))
			continue;
		
		printf("Try to move explorer from (%d,%d) to (%d,%d)\n",
			   punit->x,punit->y,new_x,new_y);
		move_unit(punit->id,new_x,new_y);
		return;
	}
	printf("WARNING: Can't move explorer\n");
}

void my_unit_changed_notify(int unit_id)
{
	struct unit *punit=find_unit_by_id(unit_id);

	printf("unit change: owner=%s id=%d type=%s pos=(%d,%d) moves left=%d\n",
		   find_player_by_id(punit->owner)->name,
		   punit->id,find_unit_type_by_id(punit->type)->name,
		   punit->x,punit->y,punit->moves_left);
	
	if(punit->owner!=game.player_id)
		return;

	if(punit->activity==ACTIVITY_FORTIFIED ||
	   punit->activity==ACTIVITY_FORTIFYING)
		return;

	if(unit_has_role(punit->id,L_EXPLORER))
	{
		move_explorer(punit);
		return;
	}

	printf("Warning: don't know what to do with unit\n");
}

void my_new_unit_notify(int unit_id)
{
	struct unit *punit=find_unit_by_id(unit_id);

	printf("new unit: owner=%s id=%d type=%s pos=(%d,%d) moves left=%d\n",
		   find_player_by_id(punit->owner)->name,
		   punit->id,find_unit_type_by_id(punit->type)->name,
		   punit->x,punit->y,punit->moves_left);

	if(punit->owner!=game.player_id)
		return;
	if(unit_has_flag(unit_id,F_CITIES))
	{
		if(build_city(unit_id))
			return;
		else
			printf("Can build city here\n");
	}
	else if(unit_has_role(punit->id,L_DEFEND_OK) ||
			unit_has_role(punit->id,L_DEFEND_GOOD))
	{
		assert(can_unit_do_activity(punit->id,ACTIVITY_FORTIFYING));
		set_unit_activity(punit->id,ACTIVITY_FORTIFYING);
		printf("set unit to fortify\n");
		return;
	}
	else if(unit_has_role(punit->id,L_EXPLORER))
	{
		move_explorer(punit);
		return;
	}

	printf("Warning: don't know what to do with new unit\n");
}

void my_unit_destroyed_notify(int unit_id)
{
	struct unit *punit=find_unit_by_id(unit_id);

	if(punit->owner!=game.player_id)
		return;
}

/* ----------- city related ------------------------ */

void my_city_changed_notify(int city_id)
{
	struct city *pcity=find_city_by_id(city_id);

	printf("City '%s' size=%d food=%d/%d, shields=%d/%d\n",
		   pcity->name,pcity->size,
		   pcity->food_prod, pcity->food_surplus,
		   pcity->shield_prod,pcity->shield_surplus);
	
	if(pcity->owner!=game.player_id)
		return;
}

void my_new_city_notify(int city_id)
{
	struct city *pcity=find_city_by_id(city_id);

	printf("New city '%s' food=%d/%d, shields=%d/%d\n",
		   pcity->name,
		   pcity->food_prod, pcity->food_surplus,
		   pcity->shield_prod,pcity->shield_surplus);

	if(pcity->owner!=game.player_id)
		return;

}

void my_city_destroyed_notify(int city_id)
{
	struct city *pcity=find_city_by_id(city_id);

	if(pcity->owner!=game.player_id)
		return;
}

static int need_defender(struct city *pcity)
{
	int units,i,defender=0;
	struct unit *punits[10];

	units=find_units_by_position(pcity->x,pcity->y,
								 10,punits);
	
	for(i=0;i<units;i++)
	{
		if(unit_has_role(punits[i]->id,L_DEFEND_OK) ||
		   unit_has_role(punits[i]->id,L_DEFEND_GOOD))
			defender++;
	}
	return (defender<2);
}

static int get_best_defender(struct city *pcity)
{
	int best_defense_unit_type=-1, best_power=-1,i;

	for(i=0;i<get_unit_types_count();i++)
	{
		int power;
		struct unit_type *ptype;

		if(!unit_type_has_role(i,L_DEFEND_OK) &&
		   !unit_type_has_role(i,L_DEFEND_GOOD))
			continue;
		if(!can_city_build_unit_type(pcity->id,i))
			continue;

		ptype=find_unit_type_by_id(i);
		power=ptype->attack_strength + ptype->defense_strength;
	  
		if(power>best_power)
		{
			best_power=power;
			best_defense_unit_type=i;
		}
	}
	assert(best_power!=-1);
	return best_defense_unit_type;
}

void my_city_construction_finished_notify(int city_id)
{
	struct city *pcity=find_city_by_id(city_id);

	if(pcity->owner!=game.player_id)
		return;

	if(need_defender(pcity) || pcity->size<2)
	{
		int best_defender=get_best_defender(pcity);
		
		printf("%s needs defense lets build %s\n",pcity->name,
			   find_unit_type_by_id(best_defender)->name);
		set_construction_to_unit(city_id, best_defender);
	}
	else
		set_construction_to_unit(city_id, 
								 find_unit_type_by_name("Settlers")->id);
}

void register_callbacks()
{
	set_select_nation_cb(my_select_nation);
	set_game_started_notify_cb(my_game_started_notify);
	set_new_year_notify_cb(my_new_year_notify);
	set_name_new_city_cb(my_name_new_city);
	set_choose_science_cb(my_choose_science);
	set_choose_government_cb(my_choose_government);

	set_unit_changed_notify_cb(my_unit_changed_notify);
	set_new_unit_notify_cb(my_new_unit_notify);
	set_unit_destroyed_notify_cb(my_unit_destroyed_notify);

	set_city_changed_notify_cb(my_city_changed_notify);
	set_new_city_notify_cb(my_new_city_notify);
	set_city_destroyed_notify_cb(my_city_destroyed_notify);
	set_city_construction_finished_notify_cb(my_city_construction_finished_notify);
}
